#include "entities.hpp"
#include "gamestrings.hpp"
#include "mathstuff.hpp"

bool Lover::visible()
{
/*

 //left screen
 {{1.5,0.1},{1.5,0.5}},
 {{1.5,0.5},{0.75,0.5}},
 //middle screen
 {{0.25,0.5},{-0.5,0.5}},
 //right screen
 {{-1,0.5},{-1.5,0.5}}
 */
  //int radius
  const GLfloat radius=0.10;
  if (pos.x>1.5 &&
    pos.y>0.1+radius)
    return false;
  else if (pos.y>0.5 &&
       pos.x>0.75+radius)
    return false;
  else if (pos.y>0.5 &&
       pos.x>-0.5+radius &&
       pos.x<0.25-radius)
    return false;
  else if (pos.y>0.5 &&
       pos.x>-1.5+radius &&
       pos.x<-1-radius)
    return false;
  else if (pos.x<-2)
    return false;
  else return true;
}

void Lover::calcrotate()
{
  if (moving[0])
  {
    if (moving[2])
    {
      angle=225;
    }
    else if (moving[3])
    {
      angle=135;
    }
    else
      angle=180;
  }
  else if (moving[1])
  {
    if (moving[2])
    {
      angle=315;
    }
    else if (moving[3])
    {
      angle=45;
    }
    else
      angle=0;
  }
  else if (moving[2])
  {
    angle=270;
  }
  else if (moving[3])
  {
    angle=90;
  }
};

void Lover::input(const SDL_Event& event)
{
  if( event.type == SDL_KEYDOWN )
  {

    //Adjust the velocity
    switch( event.key.keysym.sym )
    {
      case SDLK_w:
        moving[0]=1;
        break;
      case SDLK_s:
        moving[1]=1;
        break;
      case SDLK_a:
        moving[2]=1;
        break;
      case SDLK_d:
        moving[3]=1;
        break;
      default:
        break;
    }

    calcrotate();
  }
  else if( event.type == SDL_KEYUP )
  {

    switch( event.key.keysym.sym )
    {
      case SDLK_w:
        moving[0]=0;
        break;
      case SDLK_s:
        moving[1]=0;
        break;
      case SDLK_a:
        moving[2]=0;
        break;
      case SDLK_d:
        moving[3]=0;
        break;
      default:
        break;
    }

    calcrotate();

  }
};


void Lover::move(float x1,float y1,float x2,float y2)
{
  const GLfloat vel=0.03;
  if (moving[0])
  {
    bool collides=false;
    float cand=pos.y+vel;
    for (int i=0;i<wallcount;i++)
    {
      if (sqdist_Point_to_Segment(pos.x, cand, roomcollisions[i][0][0], roomcollisions[i][0][1], roomcollisions[i][1][0], roomcollisions[i][1][1])<=playerwidth*playerwidth)
        collides=true;
    }

    if (sqlength(x1-pos.x,y1-cand)<4*playerwidth*playerwidth)
      collides=true;

    if (sqlength(x2-pos.x,y2-cand)<4*playerwidth*playerwidth)
      collides=true;

    if (!collides)
      pos.y=cand;
  }
  if (moving[1])
  {
    bool collides=false;
    float cand=pos.y-vel;
    for (int i=0;i<wallcount;i++)
    {
      if (sqdist_Point_to_Segment(pos.x, cand, roomcollisions[i][0][0], roomcollisions[i][0][1], roomcollisions[i][1][0], roomcollisions[i][1][1])<=playerwidth*playerwidth)
        collides=true;
    }

    if (sqlength(x1-pos.x,y1-cand)<4*playerwidth*playerwidth)
      collides=true;

    if (sqlength(x2-pos.x,y2-cand)<4*playerwidth*playerwidth)
      collides=true;

    if (!collides)
      pos.y=cand;		}
  if (moving[2])
  {
    bool collides=false;
    float cand=pos.x+vel;
    for (int i=0;i<wallcount;i++)
    {
      if (sqdist_Point_to_Segment(cand, pos.y, roomcollisions[i][0][0], roomcollisions[i][0][1], roomcollisions[i][1][0], roomcollisions[i][1][1])<=playerwidth*playerwidth)
        collides=true;
    }

    if (sqlength(x1-cand,y1-pos.y)<4*playerwidth*playerwidth)
      collides=true;

    if (sqlength(x2-cand,y2-pos.y)<4*playerwidth*playerwidth)
      collides=true;

    if (!collides)
      pos.x=cand;
  }
  if (moving[3])
  {
    bool collides=false;
    float cand=pos.x-vel;
    for (int i=0;i<wallcount;i++)
    {
      if (sqdist_Point_to_Segment(cand, pos.y, roomcollisions[i][0][0], roomcollisions[i][0][1], roomcollisions[i][1][0], roomcollisions[i][1][1])<=playerwidth*playerwidth)
        collides=true;
    }

    if (sqlength(x1-cand,y1-pos.y)<4*playerwidth*playerwidth)
      collides=true;

    if (sqlength(x2-cand,y2-pos.y)<4*playerwidth*playerwidth)
      collides=true;

    if (!collides)
      pos.x=cand;
  }
};

void Lover::draw()
{
		glPushMatrix();
		glTranslatef(-pos.x,0,-pos.y);


		glRotatef(180+angle,0,1,0);

    glCallList(dlist);
		glPopMatrix();
};

Lover::Lover()
{
  for (int i=0;i<4;i++)
    moving[i]=0;

  pos.x=0;
  pos.y=-1;
};


void Boss::saysomething(int text_tosay)
{
  speechlength=60;
  tosay=text_tosay;
};

void Boss::draw()
{
  glPushMatrix();

  if (!onbed)
  {
    //for mesh two, offsets can be -1.9,0.2,0.2

    glTranslatef(-pos.x,0,-pos.y);


    glRotatef(angle,0,1,0);

    /*		glBegin(GL_QUADS);
     glVertex3f( -0.1f,  0.6f, -0.1f );
     glVertex3f( -0.1f,  0.6f,  0.1f );
     glVertex3f(  0.1f,  0.6f,  0.1f );
     glVertex3f(  0.1f,  0.6f, -0.1f );
     glEnd();*/

    glCallList(dlist1);
  }
  else
  {
    glTranslatef(-pos.x,0.2,-pos.y);
    glRotatef(angle,0,1,0);
    glCallList(dlist2);
  }
  glPopMatrix();


  if (speechlength>0)
  {
    fontrenderer->glPrint(184, 280, dialogue[tosay][language].c_str(), 0);
    speechlength--;
  }
};

Boss::Boss()
{
  for (int i=0;i<4;i++)
    moving[i]=0;
  pos.x=-1.3;
  pos.y=-0.75;
  angle=-90;
  speechlength=0;
}

void Wife::calcrotate()
{
  if (moving[0])
  {
    if (moving[2])
    {
      angle=225;
    }
    else if (moving[3])
    {
      angle=135;
    }
    else
      angle=180;
  }
  else if (moving[1])
  {
    if (moving[2])
    {
      angle=315;
    }
    else if (moving[3])
    {
      angle=45;
    }
    else
      angle=0;
  }
  else if (moving[2])
  {
    angle=270;
  }
  else if (moving[3])
  {
    angle=90;
  }
};


void Wife::input(const SDL_Event& event)
{
  if( event.type == SDL_KEYDOWN )
  {
    //Adjust the velocity
    switch( event.key.keysym.sym )
    {
      case SDLK_UP:
        moving[0]=1;
        break;
      case SDLK_DOWN:
        moving[1]=1;
        break;
      case SDLK_LEFT:
        moving[2]=1;
        break;
      case SDLK_RIGHT:
        moving[3]=1;
        break;
      case SDLK_SPACE:
        if (carrying==-1)
        {
          int dildoselected=-1;
          GLfloat curmaxdist=0.5*0.5;

          for (int i=0;i<3;i++)
          {
            GLfloat d=sqlength(dildo[i].x-pos.x, dildo[i].z-pos.y);
            if (d<curmaxdist)
            {
              curmaxdist=d;
              dildoselected=i;
            }
          }
          if (dildoselected>=0 && dildo[dildoselected].state==0)
          {
            dildo[dildoselected].state=1;
            carrying=dildoselected;
            if (boss->onbed==false)
              boss->saysomething(26);
            boss->onbed=true;
            boss->pos.x=-1.2+1.9;
            boss->pos.y=-1;
            boss->angle=270;
          }
        }
        else
        {
          const GLfloat curmaxdist=0.5*0.5;
          if (sqlength(boss->pos.x-pos.x, boss->pos.y-pos.y)<curmaxdist)
          {
            dildo[carrying].state=2;
            dildo[carrying].x=-1.2+1.9-0.25;
            dildo[carrying].y=-0.53;
            dildo[carrying].z=-1;
            carrying=-1;
            *hidecounter=3.1415926535/2;
            boss->saysomething(23+(rand()%5));
            boss->cansee=false;
          }
        }
        break;
      default:
        break;
    }

    calcrotate();
  }
  else if( event.type == SDL_KEYUP )
  {

    //Adjust the velocity
    switch( event.key.keysym.sym )
    {
      case SDLK_UP:
        moving[0]=0;
        break;
      case SDLK_DOWN:
        moving[1]=0;
        break;
      case SDLK_LEFT:
        moving[2]=0;
        break;
      case SDLK_RIGHT:
        moving[3]=0;
        break;
      default:
        break;
    }
    calcrotate();
  }
};

void Wife::move(float x1,float y1,float x2,float y2)
{
  const GLfloat vel=0.03;
  if (moving[0])
  {
    bool collides=false;
    float cand=pos.y+vel;
    for (int i=0;i<wallcount;i++)
    {
      if (sqdist_Point_to_Segment(pos.x, cand, roomcollisions[i][0][0], roomcollisions[i][0][1], roomcollisions[i][1][0], roomcollisions[i][1][1])<=playerwidth*playerwidth)
        collides=true;
    }

    if (sqlength(x1-pos.x,y1-cand)<4*playerwidth*playerwidth)
      collides=true;

    if (sqlength(x2-pos.x,y2-cand)<4*playerwidth*playerwidth)
      collides=true;

    if (!collides)
      pos.y=cand;
  }
  if (moving[1])
  {
    bool collides=false;
    float cand=pos.y-vel;
    for (int i=0;i<wallcount;i++)
    {
      if (sqdist_Point_to_Segment(pos.x, cand, roomcollisions[i][0][0], roomcollisions[i][0][1], roomcollisions[i][1][0], roomcollisions[i][1][1])<=playerwidth*playerwidth)
        collides=true;
    }

    if (sqlength(x1-pos.x,y1-cand)<4*playerwidth*playerwidth)
      collides=true;

    if (sqlength(x2-pos.x,y2-cand)<4*playerwidth*playerwidth)
      collides=true;

    if (!collides)
      pos.y=cand;		}
  if (moving[2])
  {
    bool collides=false;
    float cand=pos.x+vel;
    for (int i=0;i<wallcount;i++)
    {
      if (sqdist_Point_to_Segment(cand, pos.y, roomcollisions[i][0][0], roomcollisions[i][0][1], roomcollisions[i][1][0], roomcollisions[i][1][1])<=playerwidth*playerwidth)
        collides=true;
    }

    if (sqlength(x1-cand,y1-pos.y)<4*playerwidth*playerwidth)
      collides=true;

    if (sqlength(x2-cand,y2-pos.y)<4*playerwidth*playerwidth)
      collides=true;

    if (!collides)
      pos.x=cand;
  }
  if (moving[3])
  {
    bool collides=false;
    float cand=pos.x-vel;
    for (int i=0;i<wallcount;i++)
    {
      if (sqdist_Point_to_Segment(cand, pos.y, roomcollisions[i][0][0], roomcollisions[i][0][1], roomcollisions[i][1][0], roomcollisions[i][1][1])<=playerwidth*playerwidth)
        collides=true;
    }

    if (sqlength(x1-cand,y1-pos.y)<4*playerwidth*playerwidth)
      collides=true;

    if (sqlength(x2-cand,y2-pos.y)<4*playerwidth*playerwidth)
      collides=true;

    if (!collides)
      pos.x=cand;
  }
};

void Wife::draw()
{
  glPushMatrix();
  glTranslatef(-pos.x,0,-pos.y);


  glRotatef(angle,0,1,0);

  /*		glBegin(GL_QUADS);
  glVertex3f( -0.1f,  0.6f, -0.1f );
  glVertex3f( -0.1f,  0.6f,  0.1f );
  glVertex3f(  0.1f,  0.6f,  0.1f );
  glVertex3f(  0.1f,  0.6f, -0.1f );
  glEnd();*/
  glCallList(dlist);
  glPopMatrix();
}

Wife::Wife()
{
  for (int i=0;i<4;i++)
    moving[i]=0;
}
