#include "intropart.hpp"
#include "mainpart.hpp"
#include "gamestrings.hpp"

void IntroPart::reset()
{
  state->gstimer=0;
}

IntroPart::IntroPart(const SubengineInterface* subengines, Global_Variables* p_global_variables):
EnginePart(subengines),
state(new Intro_State),
global_variables(p_global_variables)
{
};

IntroPart::~IntroPart()
{
  delete state;
}

int IntroPart::input(const SDL_Event& event)
{
  if( event.type == SDL_KEYDOWN )
  {
    switch( event.key.keysym.sym )
    {
      case SDLK_ESCAPE:
        return 1;
        break;
      case SDLK_SPACE:
        if (state->gstimer<200)
          state->gstimer=200;
        else
        {
          return 1;
        }
      default:
        break;
    }
  }

  if( event.type == SDL_QUIT )
  {
    return -1;
  }

  return 0;
}

int IntroPart::logic()
{
  state->gstimer++;

		if (state->gstimer>=250)
      return 1;
    else
      return 0;
}

void IntroPart::draw()
{

		//Clear the screen
		glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

		if (state->gstimer<100)
			glColor3f(state->gstimer/100,state->gstimer/100,state->gstimer/100);
		else if (state->gstimer>200)
			glColor3f((250-state->gstimer)/50,(250-state->gstimer)/50,(250-state->gstimer)/50);

		graphicsengine->fontrenderer->glPrint(100,300,titledialog[0][0].c_str(),0);
}
